//
//  HotKeyTextView.m
//  WindowCapture
//
//  Specialized NSTextView that holds just a single character, displaying
//  modifier keys
//  Created by David Gelhar on 11/15/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "HotKeyTextField.h"
#import "NSString+KeyCodeTranslator.h"

@implementation HotKeyTextField

@synthesize modifierFlags;
@synthesize keyCode;

// Override keyDown to capture input keystrokes in our field
// Capture the keycode & modifiers; update
// display accordingly.

// Intercept keypresses; capture keycode & modifier flags
- (void)keyDown:(NSEvent *)theEvent {

    [self setKeyCode:[theEvent keyCode] withModifierFlags:[theEvent modifierFlags]];
}

// Set current keycode/modifierflags. Display graphical version of modifier flags
- (void) setKeyCode:(unsigned short) code withModifierFlags:(NSUInteger) flags {
    self.keyCode = code;
    self.modifierFlags = flags;
    
    // replace
    [self setString:[NSString stringForKeyCode:code withModifierFlags:flags]];
    [self setFont:[NSFont boldSystemFontOfSize:15.0]];

}
@end
