//
//  NSImage+ImageGrabber.m
//  WindowCaptureDemo
//
//  Created by David Gelhar on 10/23/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NSImage+ImageGrabber.h"

@implementation NSImage (ImageGrabber)

+ (NSImage *)imageWithWindow:(CGWindowID)wid {
    // snag the image
    CGImageRef windowImage = CGWindowListCreateImage(CGRectNull, kCGWindowListOptionIncludingWindow, wid, kCGWindowImageBoundsIgnoreFraming);
    // little bit of error checking
    if(CGImageGetWidth(windowImage) <= 1) {
        CGImageRelease(windowImage);
        return nil;
    }

    // convert CGImage to NSImage 
    // size:NSZeroSize means "use same size as CGImage"
    NSImage *image = [[NSImage alloc] initWithCGImage:windowImage size:NSZeroSize];

    CGImageRelease(windowImage);

    return image;   
}

@end
