#import <Carbon/Carbon.h>


static const struct { char const* const name; unichar const glyph; } mapOfNamesForUnicodeGlyphs[] =
{
// Constants defined in NSEvent.h that are expected to relate to unicode characters, but don't seen to translate properly
{ "Up",           NSUpArrowFunctionKey },
{ "Down",         NSDownArrowFunctionKey },
{ "Left",         NSLeftArrowFunctionKey },
{ "Right",        NSRightArrowFunctionKey },
{ "Home",         NSHomeFunctionKey },
{ "End",          NSEndFunctionKey },
{ "Page Up",      NSPageUpFunctionKey },
{ "Page Down",    NSPageDownFunctionKey },

//	These are the actual values that these keys translate to
{ "Up",			0x1E },
{ "Down",		0x1F },
{ "Left",		0x1C },
{ "Right",		0x1D },
{ "Home",		0x1 },
{ "End",		0x4 },
{ "Page Up",	0xB },
{ "Page Down",	0xC },
{ "Return",		0x3 },
{ "Tab",		0x9 },
{ "Backtab",	0x19 },
{ "Enter",		0xd },
{ "Backspace",	0x8 },
{ "Delete",		0x7F },
{ "Escape",		0x1b },
{ "Space",		0x20 }

};

// Need to update this value if you modify mapOfNamesForUnicodeGlyphs
#define NumberOfUnicodeGlyphReplacements 24


@interface NSString (KeyCodeTranslator)

+ (NSString *)stringForKeyCode:(unsigned short)keyCode withModifierFlags:(NSUInteger)modifierFlags;

@end