//
//  PreferencesController.m
//  WindowCapture
//
//  Created by David Gelhar on 11/15/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "PreferencesController.h"
#import "AppDelegate.h"
#import "Carbon/Carbon.h"

@implementation PreferencesController

@synthesize hotkeyField,keyCode,modifierFlags;

- (id)initWithWindowNibName:(NSString *)windowNibName
{
    self = [super initWithWindowNibName:windowNibName];
    if (self) {
        self.keyCode = [[NSUserDefaults standardUserDefaults] integerForKey:@"keyCode"];
        self.modifierFlags = [[NSUserDefaults standardUserDefaults] integerForKey:@"modifierFlags"];
        if (self.keyCode == 0) { // if no defaults stored
            self.keyCode = kVK_ANSI_M; // fall back to ctrl-option-cmd-M
            self.modifierFlags = NSControlKeyMask|NSAlternateKeyMask|NSCommandKeyMask; 
        }
        
    }
    
    return self;
}

- (void)windowDidLoad
{
    [super windowDidLoad];
    [hotkeyField setKeyCode:self.keyCode withModifierFlags:self.modifierFlags];
   
}

// Record new hotkey setting in defaults
// Re-register listener for the new hotkey
-(void) saveChanges:(id) sender {
    self.keyCode = hotkeyField.keyCode;
    self.modifierFlags = hotkeyField.modifierFlags;
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults setInteger:self.keyCode forKey:@"keyCode"];
    [defaults setInteger:self.modifierFlags forKey:@"modifierFlags"];
    [defaults synchronize];
    
    [[self window] orderOut:nil];   // close window after saving
    
    // re-register the new hotkey
    AppDelegate *appDelegate = [[NSApplication sharedApplication] delegate];
    [appDelegate registerHotKey:self.keyCode withModifierFlags:self.modifierFlags];
}


@end
